<?php
class DMExport {
	
	function Export($profile, $from, $to, $backup_dir){
		global $db;
		ob_start();
		
		$profile->datamanagerDir = $backup_dir;
		
		# Export the .gzipped backup file.
		set_time_limit(86400);
		
		$q = $db->Execute("SELECT MIN(timestamp) as mindate, MAX(timestamp) as maxdate FROM {$profile->tablename}");
		$data = $q->FetchRow();
		if ($from < $data["mindate"] && $to < $data["mindate"]) {
			echo "The date range you chose is not available in the database. Database data spans from ".date("Y-m-d",$data["mindate"]) . " to ".date("Y-m-d",$data["maxdate"]);
			return;
		}
		
		if($from < $data["mindate"]){
			$from = $data["mindate"];
		}		
		if($to > $data["maxdate"]){
			$to = $data["maxdate"];
		}		
		
		echo "exporting from ".date("Ymd",$from) . " to ".date("Ymd",$to)."\n<br>";
		@lgflush();
		
		$export_table = $profile->tablename;  
		
		
		$time =  mktime(00, 00, 00,date("m",$from), date("d",$from), date("Y",$from)); 
		$oriTo = $to;
		while($time <= $oriTo) {
			
			$to = $time + 86399;
			# get all data from the database within the daterange
			$query = "SELECT a.timestamp, 
						v.ipnumber AS ipnumber, 
						u.url AS url, 
						up.params AS params, 
						a.status, a.bytes, 
						r.referrer AS referrer,
						k.keywords as keywords,
						rp.params AS refparams, 
						b.useragent AS useragent,
						v.visitorid as visitorid,
						a.sessionid as sessionid,
						a.crawl as crawl,
						a.country as country

					FROM {$export_table} as a, 
						{$profile->tablename_visitorids} AS v, 
						{$profile->tablename_urls} AS u, 
						{$profile->tablename_urlparams} AS up, 
						{$profile->tablename_referrers} AS r,
						{$profile->tablename_keywords} as k,
						{$profile->tablename_refparams} AS rp, 
						{$profile->tablename_useragents} AS b 

					WHERE a.timestamp >= {$time} 
						and a.timestamp <= {$to} 
						AND (a.visitorid = v.id
						AND a.url = u.id 
						AND a.params = up.id 
						AND a.referrer = r.id
						and a.keywords = k.id
						AND a.refparams = rp.id 
						AND a.useragentid = b.id)

					ORDER BY a.timestamp";
			
			$bupfile = "{$profile->datamanagerDir}{$profile->profilename}/log/". date("Ymd",$time).".gz";
						
			$dir_1 = "{$profile->datamanagerDir}{$profile->profilename}";
			$dir_2 = $dir_1."/log/";
			if(!file_exists($bupfile)) {
				if(!file_exists($dir_1)) {
					mkdir($dir_1);
					//set_permissions($dir_1);
				}
				if(!file_exists($dir_2)) {
					mkdir($dir_2);
					//set_permissions($dir_2);
				}
			} else {
				# if the file exists, we'll assume we only need to regenerate it if it is the last file, so check if the next file exists
				$test = "{$profile->datamanagerDir}{$profile->profilename}/log/". date("Ymd",($time+86400)).".gz";
				if(file_exists($test)) {
					$time = $time + 86400;
					//echo "skipping $bupfile<br>";
					continue;
				}
			}
						
			$fp = gzopen ($bupfile,"w");
			$buffer = "";
			
			$q = $db->Execute($query);
			while ($data=$q->FetchRow()) {
				if ($data["refparams"]=="?") {
					$data["refparams"]="-";
				}				
				
				$buffer = $data["ipnumber"]
				."|LWA|". "-"
				."|LWA|". "-"
				."|LWA|". $data["timestamp"]
				."|LWA|". ""
				."|LWA|". $data["url"] 
				."|LWA|". $data["status"]
				."|LWA|". $data["bytes"]
				."|LWA|". $data["referrer"]
				."|LWA|". $data["useragent"]
				."|LWA|". md5($data["useragent"])
				."|LWA|". "" 
				."|LWA|". $data["params"]				
				."|LWA|". $data["refparams"]
				."|LWA|". $data["keywords"]
				."|LWA|". $data["visitorid"]
				."|LWA|". $data["country"]
				."|LWA|". $data["crawl"]
				."|LWA|". $data["sessionid"]
				. "\n";
				
				gzwrite ($fp, $buffer);
			}
			gzclose ($fp);
			//set_permissions($bupfile);

			//$this->LogProcess("wrote file: $bupfile<br>");	
			echo "wrote file: $bupfile<br>";
				
			@lgflush();
			$time = $time + 86400;
		}
	}
}
?>