<?php

class ProfileImportExport {

	var $exportLocation;
	var $importLocation;
	var $profile;
	
	function exportProfileSettings() {
		global $db;
		
		$file = $this->exportLocation 
              . 'logaholic_' 
              // . $this->username 
              // . '_' 
              . $this->profile 
              . '_' 
              . 'settings.json';
        
        $fh = fopen($file, 'w');
		
        if($fh === false){
            echo("Fatal error: no filehandle for '$file'\n");
            exit();
        }
		
		$db->SetFetchMode(ADODB_FETCH_ASSOC);
		$q = $db->Execute("select * from ".TBL_PROFILES." where profilename=\"$this->profile\"");
		$data = $q->FetchRow();
		fwrite($fh, json_encode($data) . "\n");

		$q = $db->Execute("select * from ".TBL_GLOBAL_SETTINGS." where profile=\"$this->profile\" and name NOT LIKE 'cache%'");
		while ($data = $q->FetchRow()) {
			fwrite($fh, json_encode($data) . "\n");
		}
		$db->SetFetchMode(ADODB_FETCH_BOTH);
		fclose($fh);
		echo "Profile settings saved in file: $file";
        return true;		
	}
	
	function importProfileSettings() {
		global $db;
		
		$file = $this->importLocation; 

        $fh = fopen($file, 'r');
		
        if($fh === false){
            echo("Fatal error: no filehandle for '$file'\n");
            exit();
        }
		
		while ($line=fgets($fh)) {
			$line = json_decode($line, true);
			if (isset($line["profilename"])) {
				$this->profile = $line["profilename"];
			}
			if (isset($line["profileid"])) {
				# handle the profile table entry
				if (empty($this->profile)) {
					echoWarning("Error: unknown profile name\n");
					exit();
				}
				if ($this->profileExists($this->profile)==true) {
					echoWarning("Error: Profile '$this->profile' already exists in this database\n");
					exit();    
				}
				
				# add the new profile to the profile list in the user table
				// $dbp->username = $this->username;
				// if ($dbp->AddProfiletoUser($this->profile)===FALSE) {
					// exit();
				// }
								
				# ok, now create the new profile based on this info
				$profile = new SiteProfile();

				foreach($line as $k => $v) {
					if ($k=="profileid" || $k=="tablename") {
						# skip this to avoid conflicts on this new server
						continue;					
					}
					$profile->$k = $v;
				}
				$profile->Save();
				createDataTable($profile);			
				
			} else if (isset($line["Profile"])){
				# handle the global setting table entries
				setProfileData($line["Profile"],$line["Name"],$line["Value"]);
			} else {
				echoWarning("Error Invalid data in settings file $file \n");
			}
		}
		echoNotice("Success: Imported profile settings for $profile->profilename \n"); 
		if ($profile->trackermode==1) {
			echoWarning("You will need to update the Javascript tracking code on {$profile->confdomain}. Go to: Edit Profile > Data collection tab. Copy the new code and replace the old code in the website.");
		}
		
		fclose($fh);
        return true;		
	}
	
	function profileExists($name) {
        global $db;
        
        $q = $db->Execute("select profileid from ".TBL_PROFILES." where profilename=\"$name\"");
        if ($q->NumRows() > 0) {
            return true;    
        } else {
            return false;    
        }            
    }


}

?>